using System;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace HeuristicLab.Services.Optimization.Web {
  public static class Constants {
    public const string DiagnosticsConnectionString = "Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString";
  }

  public class WebRole : RoleEntryPoint {
    public override bool OnStart() {
      // For information on handling configuration changes
      // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.      
      try {
        if (!String.IsNullOrEmpty(RoleEnvironment.GetConfigurationSettingValue(Constants.DiagnosticsConnectionString))) {
          DiagnosticMonitorConfiguration dmc = DiagnosticMonitor.GetDefaultInitialConfiguration();
          dmc.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
          dmc.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
          DiagnosticMonitor.Start(Constants.DiagnosticsConnectionString, dmc);
        }
      }
      catch (RoleEnvironmentException) {
        // diagnostics connection string not in configuration
        // -> diagnostics disabled
        // nothing more to do
      }

      RoleEnvironment.Changed += RoleEnvironmentChanged;

      return base.OnStart();
    }

    private void RoleEnvironmentChanged(object sender, RoleEnvironmentChangedEventArgs e) {
    }
  }
}
